//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  vector<int> coll1;
  list<int> coll2;

  INSERT_ELEMENTS(coll1,1,9);
  PRINT_ELEMENTS(coll1,"1- :\n");

  //    
  transform (coll1.begin(), coll1.end(),       //  
             coll1.begin(),                    //  
             coll1.begin(),                    // 
             multiplies<int>());               // 
  PRINT_ELEMENTS(coll1,"1-  (  ):\n");

  //       
  //        
  //      coll2
  transform (coll1.begin(), coll1.end(),       //  
             coll1.rbegin(),                   //  
             back_inserter(coll2),             // 
             plus<int>());                     // 
  PRINT_ELEMENTS(coll2,"2- :\n");

  //    
  cout << ToRus(":\n");
  transform (coll1.begin(), coll1.end(),       //  
             coll2.begin(),                    //  
             ostream_iterator<int>(cout, " "), // 
             minus<int>());                    // 
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------